//----------------------------------------------------------------------------

//LEVEL
//  

//----------------------------------------------------------------------------

#include "Main.h"
#include "Commands.h"
#include "Wake.h"
#include "Port.h"
#include "Usonic.h"

//------------------------------ : ----------------------------------

const __flash char Info[] = {"LEVEL"}; // 

//---------------------------  : -----------------------------

void Tx_Replay(char n, char err); //   

//----------------------    : -------------------------

void Tx_Replay(char n, char err)
{
  Tx_Nbt = n;        // 
  Tx_Dat[0] = err;   // 
  Tx_Cmd = Command;  //
  Port_Tx_Frame();   // 
  Command = CMD_NOP; // 
}

//----------------------------  : ----------------------------

void Commands_Exe(void)
{
  if(Command != CMD_NOP)
  {
    char i;
    switch(Command)
    {
    case CMD_ERR: // 
      {
        Tx_Replay(1, ERR_TX);
        break;
      }
    case CMD_ECHO: // ""
      {
        for(i = 0; i < Rx_Nbt && i < FRAME; i++)
          Tx_Dat[i] = Rx_Dat[i];
        Tx_Replay(Rx_Nbt, Tx_Dat[0]);
        break;
      }
    case CMD_INFO: // ""
      {
        char ch = 1;
        for(i = 0; i < FRAME && ch; i++)
          ch = Tx_Dat[i] = Info[i];
        Tx_Replay(i, Tx_Dat[0]);
        break;
      }
    case CMD_LEVEL: //  
      {
        unsigned int v = Usonic_GetLevel();
        Tx_Dat[1] = LO(v);
        Tx_Dat[2] = HI(v);
        Tx_Replay(3, ERR_NO);
        break;
      }
    }
  }
}

//----------------------------------------------------------------------------
