//----------------------------------------------------------------------------

//LEVEL
// :  

//----------------------------------------------------------------------------

#ifndef MainH
#define MainH

//----------------------------------------------------------------------------

#include <iom48.h>
#include <intrinsics.h>
#include <stdbool.h>

//------------------------------ : ----------------------------------

#define	F_CLK    4.0 // , 
#define T_SYS 1000.0 //  , 

//----------------------------------------------------------------------------
//---------------------------  : -------------------------------
//----------------------------------------------------------------------------

//I - 
//O - 
//B -  

//L -   
//H -   
//X -   
//A -  

//-------------------------------  B: ------------------------------------

#define UIN      (1 << PB0) //IL -   
#define LED3     (1 << PB1) //OL -   TOP
//#define REL      (1 << PB2) //OH -  
#define NC_PB2   (1 << PB2) //IL -  
#define ADDR1    (1 << PB3) //IL -   1
#define ADDR2    (1 << PB4) //IL -   2
#define ADDR3    (1 << PB5) //IL -   3

//:
//#define I_DDRB  (LED3 | REL)
#define I_DDRB  (LED3)
//  /  :
#define I_PORTB (UIN | LED3 | NC_PB2 | ADDR1 | ADDR2 | ADDR3)
//    :
#define Pin_UIN       (PINB & UIN)
#define Port_LED3_1   (PORTB |= LED3)
#define Port_LED3_0   (PORTB &= ~LED3)
//#define Port_REL_1    (PORTB |= REL)
//#define Port_REL_0    (PORTB &= ~REL)
#define Pin_ADDR1     (PINB & ADDR1)
#define Pin_ADDR2     (PINB & ADDR2)
#define Pin_ADDR3     (PINB & ADDR3)

//-------------------------------  C: ------------------------------------

#define ADDR4    (1 << PC0) //IL -   4
#define ADDR5    (1 << PC1) //IL -   5
#define ADDR6    (1 << PC2) //IL -   6
#define ADDR7    (1 << PC3) //IL -   7
#define LED2     (1 << PC4) //OL -   MID
#define LINK     (1 << PC5) //OL -   LINK

//:
#define I_DDRC  (LED2 | LINK)
//  /  :
#define I_PORTC (ADDR4 | ADDR5 | ADDR6 | ADDR7 | LED2 | LINK)
//    :
#define Pin_ADDR4     (PINC & ADDR4)
#define Pin_ADDR5     (PINC & ADDR5)
#define Pin_ADDR6     (PINC & ADDR6)
#define Pin_ADDR7     (PINC & ADDR7)
#define Port_LED2_1   (PORTC |= LED2)
#define Port_LED2_0   (PORTC &= ~LED2)
#define Port_LINK_1   (PORTC |= LINK)
#define Port_LINK_0   (PORTC &= ~LINK)

//-------------------------------  D: ------------------------------------

#define RXD      (1 << PD0) //IL -  RS-485 RXD
#define TXD      (1 << PD1) //OL -  RS-485 TXD
#define DIR      (1 << PD2) //OH -  RS-485 DIR
#define SND      (1 << PD3) //OL -   (OC2B)
#define LED1     (1 << PD4) //OL -   BOT
#define UOUT     (1 << PD5) //OH -    (OC0B)
//#define SEN      (1 << PD6) //IA -    (AIN0)
#define REL      (1 << PD6) //OH -  
#define REF      (1 << PD7) //IA -    (AIN1)

//:
//#define I_DDRD  (TXD | DIR | SND | LED1 | UOUT)
#define I_DDRD  (TXD | DIR | SND | LED1 | UOUT | REL)
//  /  :
#define I_PORTD (RXD | TXD | SND | LED1)
//    :
#define Port_DIR_0    (PORTD &= ~DIR)
#define Port_DIR_1    (PORTD |= DIR)
#define Port_LED1_0   (PORTD &= ~LED1)
#define Port_LED1_1   (PORTD |= LED1)
#define Port_REL_1    (PORTD |= REL)
#define Port_REL_0    (PORTD &= ~REL)

//----------------------------------------------------------------------------
//------------------------  : --------------------------
//----------------------------------------------------------------------------

//Timer0:  - [Usonic]
//Timer1:     [Usonic]
//Timer2:   [Main],   [Sound]
//SPI:    NOT USED
//USART:    RS-485 [Port]
//TWI:    NOT USED
//ADC:    NOT USED
//Comp:   NOT USED

//----------------------------------------------------------------------------
//-----------------------  : --------------------------
//----------------------------------------------------------------------------

//TIMER1_COMPA:   [Usonic]
//TIMER1_CAPT:    [Usonic]
//TIMER2_COMPA:   [Main]
//USART_RX:       [Port]
//USART_TX:       [Port]

//--------------------------- : ------------------------------

#define LO(x)    ((char)((x) & 0xFF))
#define HI(x)    ((char)(((x) >> 8) & 0xFF))
#define BYTE1(x) (LO(x))
#define BYTE2(x) (HI(x))
#define BYTE3(x) ((char)(((unsigned long)(x) >> 16) & 0xFF))
#define BYTE4(x) ((char)(((unsigned long)(x) >> 24) & 0xFF))

#define WORD(b1,b0)        (((unsigned int)(b1) << 8) | (b0))
#define DWORD(b3,b2,b1,b0) (((unsigned long)WORD(b3,b2) << 16) | WORD(b1,b0))

#define ABS(x) (((x) < 0)? -(x) : (x))

#define Delay_us(x) __delay_cycles((unsigned int)((x) * F_CLK + 0.5))
#define ms2sys(x) ((unsigned int)(1E3 * (x) / T_SYS))
#define s2sys(x) ((unsigned long)(1E6 * (x) / T_SYS))

//----------------------------------------------------------------------------

#endif
